<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="../bower_components/polymer/lib/elements/dom-if.html">
<link rel="import" href="../bower_components/iron-ajax/iron-ajax.html">
<link rel="import" href="../bower_components/vaadin-text-field/vaadin-text-field.html">
<link rel="import" href="../bower_components/vaadin-grid/vaadin-grid.html">
<link rel="import" href="../bower_components/vaadin-grid/vaadin-grid-filter.html">
<link rel="import" href="../bower_components/vaadin-button/vaadin-button.html">
<link rel="import" href="../bower_components/iron-icon/iron-icon.html">
<link rel="import" href="../bower_components/vaadin-icons/vaadin-icons.html">
<link rel="import" href="../bower_components/brum-global-variable/brum-global-variable.html">
<link rel="import" href="shared-styles.html">

<dom-module id="submissions-list">
  <template>
    <style include="shared-styles">
      :host {
        display: block;
        background: transparent;
      }
      vaadin-grid-filter {
        width: 100%;
      }
      vaadin-text-field {
        width: 100%;
      }
    </style>

    <brum-global-variable key="apiBase" value="{{apiBase}}" readonly id="apiVariable"></brum-global-variable>
    <brum-global-variable key="backendBase" value="{{backendBase}}" readonly id="backendVariable"></brum-global-variable>
    <brum-global-variable key="teamAuth" value="{{teamAuth}}" readonly></brum-global-variable>

    <iron-ajax with-credentials auto url="[[apiBase]]/submissions" last-response="{{submissions}}"></iron-ajax>

    <div class="card">
      <vaadin-grid items="[[submissions.result]]">

        <vaadin-grid-column>
          <template class="header">Date</template>
          <template>[[item.date]]</template>
        </vaadin-grid-column>

        <vaadin-grid-column>
          <template class="header">Status</template>
          <template>[[item.status]]</template>
        </vaadin-grid-column>

        <vaadin-grid-column>
          <template class="header">ID</template>
          <template>
            <a>[[_formatImageId(item.imageId)]]</a>
          </template>
        </vaadin-grid-column>

        <vaadin-grid-column>
          <template class="header">Build</template>
          <template>
            <a href="[[backendBase]]/containers/[[item.containerId]]/logs">Logs</a>
          </template>
        </vaadin-grid-column>

        <template is="dom-if" if="[[teamAuth]]">
          <vaadin-grid-column>
            <template class="header">Deployment</template>
            <template>
              <template is="dom-if" if="[[_equal(item.status, 'ready')]]">
                <vaadin-button theme="primary" on-click="[[_deploy(item.imageId)]]">
                  <iron-icon icon="vaadin:fire" slot="prefix"></iron-icon>
                  Deploy
                  </vaadin-button>
              </template>
            </template>
            </vaadin-grid-column>
        </template>

      </vaadin-grid>
    </div>
  </template>
  <script>
    class SubmissionsList extends Polymer.Element {
      static get is() {
        return 'submissions-list';
      }

      // noinspection JSUnusedGlobalSymbols
      static get properties() {
        return {};
      }

      // noinspection JSMethodCanBeStatic
      // noinspection JSUnusedGlobalSymbols
      _formatImageId(imageId) {
        try {
          return imageId.match(/^(?:[a-z0-9]+:)?([a-z0-9]{12})/)[1];
        } catch (e) {
          return imageId;
        }
      }
      
      _equal(firstArg, ...args) {
        return args.reduce((a, v) => ({r: a.r && v === a.v, v: v}), {r: true, v: firstArg}).r;
      }

      _deploy(imageId) {
        fetch(this.$.apiVariable.value + "/deploy/" + imageId, {
          method: 'POST',
          mode: 'cors',
        }).then(response => {
          // trigger full reload
          const oldBackend = this.$.backendVariable.value;
          this.$.backendVariable.value = '://' + oldBackend; // impossible url...
          this.$.backendVariable.value = oldBackend;
        })
      }
    }

    window.customElements.define(SubmissionsList.is, SubmissionsList);
  </script>
</dom-module>
